

#ifndef     _IMPLEMENTATION_H
#define     _IMPLEMENTATION_H

#ifndef     ALG_ALL
#define     ALG_ALL     NO
#endif



#include    "BaseTypes.h" 
#include	"tss/compat11b.h"

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

// Table 204 -- SHA1 Hash Values
#define    SHA1_DIGEST_SIZE    20
#define    SHA1_BLOCK_SIZE     64
#define    SHA1_DER_SIZE       15
#define    SHA1_DER            {\
    0x30,0x21,0x30,0x09,0x06,0x05,0x2B,0x0E,0x03,0x02,0x1A,0x05,0x00,0x04,0x14}

// Table 205 -- SHA256 Hash Values
#define    SHA256_DIGEST_SIZE    32
#define    SHA256_BLOCK_SIZE     64
#define    SHA256_DER_SIZE       19
#define    SHA256_DER            {\
    0x30,0x31,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x01,\
    0x05,0x00,0x04,0x20}


// Table 206 -- SHA384 Hash Values
#define    SHA384_DIGEST_SIZE    48
#define    SHA384_BLOCK_SIZE     128
#define    SHA384_DER_SIZE       19
#define    SHA384_DER            {\
    0x30,0x41,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x02,\
    0x05,0x00,0x04,0x30}


// Table 207 -- SHA512 Hash Values
#define    SHA512_DIGEST_SIZE    64
#define    SHA512_BLOCK_SIZE     128
#define    SHA512_DER_SIZE       19
#define    SHA512_DER            {\
    0x30,0x51,0x30,0x0d,0x06,0x09,0x60,0x86,0x48,0x01,0x65,0x03,0x04,0x02,0x03,\
    0x05,0x00,0x04,0x40}


// Table 208 -- WHIRLPOOL512 Hash Values
#define    WHIRLPOOL512_DIGEST_SIZE    64
#define    WHIRLPOOL512_BLOCK_SIZE     64
#define    WHIRLPOOL512_DER_SIZE       0
#define    WHIRLPOOL512_DER            {0}


// Table 209 -- SM3_256 Hash Values
#define    SM3_256_DIGEST_SIZE    32
#define    SM3_256_BLOCK_SIZE     64
#define    SM3_256_DER_SIZE       18
#define    SM3_256_DER            {\
    0x30,0x30,0x30,0x0c,0x06,0x08,0x2A,0x81,0x1C,0x81,0x45,0x01,0x83,0x11,0x05,\
    0x00,0x04,0x20}


// Table 210 -- Architectural Limits Values
#define    MAX_SESSION_NUMBER    3


// Table 211 -- Minimum and Maximum Values
 #if 0
#define    UINT8_MAX     255
#define    BYTE_MAX      255
#define    INT8_MIN      -128
#define    INT8_MAX      127
#define    UINT16_MAX    65535
#define    INT16_MIN     -32768
#define    INT16_MAX     32767
#define    UINT32_MAX    4294967295
#define    INT32_MIN     -2147483648
#define    INT32_MAX     2147483647
#define    UINT64_MAX    18446744073709551615
#define    INT64_MIN     -9223372036854775808
#define    INT64_MAX     9223372036854775807
#endif


// Table 212 -- Logic Values
#define    YES      1
#define    NO       0
#define    TRUE     1
#define    FALSE    0
#define    SET      1
#define    CLEAR    0


// Table 213 -- Processor Values
#define    BIG_ENDIAN_TPM       NO    // 0
#define    LITTLE_ENDIAN_TPM    YES    // 1
#define    NO_AUTO_ALIGN        NO    // 0


// Table 214 -- Implemented Algorithms
#define    ALG_RSA               YES    // 1
#define    ALG_DES               NO    // 0
#define    ALG__3DES             NO    // 0
#define    ALG_SHA1              YES    // 1
#define    ALG_HMAC              YES    // 1
#define    ALG_AES               YES    // 1
#define    ALG_MGF1              YES    // 1
#define    ALG_XOR               YES    // 1
#define    ALG_KEYEDHASH         YES    // 1
#define    ALG_SHA256            YES    // 1
#define    ALG_SHA384            YES    // 0
#define    ALG_SHA512            YES    // 0
#define    ALG_WHIRLPOOL512      YES    // 0
#define    ALG_SM3_256           YES    // 1
#define    ALG_SM4               YES    // 1
#define    ALG_RSASSA            YES    // 1
#define    ALG_RSAES             YES    // 1
#define    ALG_RSAPSS            YES    // 1
#define    ALG_OAEP              YES    // 1
#define    ALG_ECC               YES    // 1
#define    ALG_ECDH              YES    // 1
#define    ALG_ECDSA             YES    // 1
#define    ALG_ECDAA             YES    // 1
#define    ALG_SM2               YES    // 1
#define    ALG_ECSCHNORR         YES    // 1
#define    ALG_SYMCIPHER         YES    // 1
#define    ALG_KDF1_SP800_56a    YES    // 1
#define    ALG_KDF2              NO    // 0
#define    ALG_KDF1_SP800_108    YES    // 1
#define    ALG_CTR               YES    // 1
#define    ALG_OFB               YES    // 1
#define    ALG_CBC               YES    // 1
#define    ALG_CFB               YES    // 1
#define    ALG_ECB               YES    // 1


// Table 215 -- Implemented Commands
#define    CC_ActivateCredential            YES    // 1
#define    CC_Certify                       YES    // 1
#define    CC_CertifyCreation               YES    // 1
#define    CC_ChangeEPS                     YES    // 1
#define    CC_ChangePPS                     YES    // 1
#define    CC_Clear                         YES    // 1
#define    CC_ClearControl                  YES    // 1
#define    CC_ClockRateAdjust               YES    // 1
#define    CC_ClockSet                      YES    // 1
#define    CC_Commit                        ALG_ECC    // 1
#define    CC_ContextLoad                   YES    // 1
#define    CC_ContextSave                   YES    // 1
#define    CC_Create                        YES    // 1
#define    CC_CreatePrimary                 YES    // 1
#define    CC_DictionaryAttackLockReset     YES    // 1
#define    CC_DictionaryAttackParameters    YES    // 1
#define    CC_Duplicate                     YES    // 1
#define    CC_ECC_Parameters                ALG_ECC    // 1
#define    CC_ECDH_KeyGen                   ALG_ECC    // 1
#define    CC_ECDH_ZGen                     ALG_ECC    // 1
#define    CC_EncryptDecrypt                YES    // 1
#define    CC_EventSequenceComplete         YES    // 1
#define    CC_EvictControl                  YES    // 1
#define    CC_FieldUpgradeData              NO    // 0
#define    CC_FieldUpgradeStart             NO    // 0
#define    CC_FirmwareRead                  NO    // 0
#define    CC_FlushContext                  YES    // 1
#define    CC_GetCapability                 YES    // 1
#define    CC_GetCommandAuditDigest         YES    // 1
#define    CC_GetRandom                     YES    // 1
#define    CC_GetSessionAuditDigest         YES    // 1
#define    CC_GetTestResult                 YES    // 1
#define    CC_GetTime                       YES    // 1
#define    CC_Hash                          YES    // 1
#define    CC_HashSequenceStart             YES    // 1
#define    CC_HierarchyChangeAuth           YES    // 1
#define    CC_HierarchyControl              YES    // 1
#define    CC_HMAC                          YES    // 1
#define    CC_HMAC_Start                    YES    // 1
#define    CC_Import                        YES    // 1
#define    CC_IncrementalSelfTest           YES    // 1
#define    CC_Load                          YES    // 1
#define    CC_LoadExternal                  YES    // 1
#define    CC_MakeCredential                YES    // 1
#define    CC_NV_Certify                    YES    // 1
#define    CC_NV_ChangeAuth                 YES    // 1
#define    CC_NV_DefineSpace                YES    // 1
#define    CC_NV_Extend                     YES    // 1
#define    CC_NV_GlobalWriteLock            YES    // 1
#define    CC_NV_Increment                  YES    // 1
#define    CC_NV_Read                       YES    // 1
#define    CC_NV_ReadLock                   YES    // 1
#define    CC_NV_ReadPublic                 YES    // 1
#define    CC_NV_SetBits                    YES    // 1
#define    CC_NV_UndefineSpace              YES    // 1
#define    CC_NV_UndefineSpaceSpecial       YES    // 1
#define    CC_NV_Write                      YES    // 1
#define    CC_NV_WriteLock                  YES    // 1
#define    CC_ObjectChangeAuth              YES    // 1
#define    CC_PCR_Allocate                  YES    // 1
#define    CC_PCR_Event                     YES    // 1
#define    CC_PCR_Extend                    YES    // 1
#define    CC_PCR_Read                      YES    // 1
#define    CC_PCR_Reset                     YES    // 1
#define    CC_PCR_SetAuthPolicy             YES    // 1
#define    CC_PCR_SetAuthValue              YES    // 1
#define    CC_PolicyAuthorize               YES    // 1
#define    CC_PolicyAuthValue               YES    // 1
#define    CC_PolicyCommandCode             YES    // 1
#define    CC_PolicyCounterTimer            YES    // 1
#define    CC_PolicyCpHash                  YES    // 1
#define    CC_PolicyDuplicationSelect       YES    // 1
#define    CC_PolicyGetDigest               YES    // 1
#define    CC_PolicyLocality                YES    // 1
#define    CC_PolicyNameHash                YES    // 1
#define    CC_PolicyNV                      YES    // 1
#define    CC_PolicyOR                      YES    // 1
#define    CC_PolicyPassword                YES    // 1
#define    CC_PolicyPCR                     YES    // 1
#define    CC_PolicyPhysicalPresence        YES    // 1
#define    CC_PolicyRestart                 YES    // 1
#define    CC_PolicySecret                  YES    // 1
#define    CC_PolicySigned                  YES    // 1
#define    CC_PolicyTicket                  YES    // 1
#define    CC_PP_Commands                   YES    // 1
#define    CC_Quote                         YES    // 1
#define    CC_ReadClock                     YES    // 1
#define    CC_ReadPublic                    YES    // 1
#define    CC_Rewrap                        YES    // 1
#define    CC_RSA_Decrypt                   ALG_RSA    // 1
#define    CC_RSA_Encrypt                   ALG_RSA    // 1
#define    CC_SelfTest                      YES    // 1
#define    CC_SequenceComplete              YES    // 1
#define    CC_SequenceUpdate                YES    // 1
#define    CC_SetAlgorithmSet               YES    // 1
#define    CC_SetCommandCodeAuditStatus     YES    // 1
#define    CC_SetPrimaryPolicy              YES    // 1
#define    CC_Shutdown                      YES    // 1
#define    CC_Sign                          YES    // 1
#define    CC_StartAuthSession              YES    // 1
#define    CC_Startup                       YES    // 1
#define    CC_StirRandom                    YES    // 1
#define    CC_TestParms                     YES    // 1
#define    CC_Unseal                        YES    // 1
#define    CC_VerifySignature               YES    // 1
#define    CC_SM2_ZGen                      YES    // 1


// Table 216 -- RSA Algorithm Constants
#define    RSA_KEY_SIZES_BITS    {1024, 2048}    // {1024,2048}
#define    MAX_RSA_KEY_BITS      2048
#define    MAX_RSA_KEY_BYTES     ((MAX_RSA_KEY_BITS + 7) / 8)    // 256


// Table 217 -- ECC Algorithm Constants
#define    ECC_CURVES            {\
    TPM_ECC_NIST_P256,TPM_ECC_BN_P256,TPM_ECC_SM2_P256}#define    ECC_KEY_SIZES_BITS    {256}
#define    MAX_ECC_KEY_BITS      256
#define    MAX_ECC_KEY_BYTES     ((MAX_ECC_KEY_BITS + 7) / 8)    // 32


// Table 218 -- AES Algorithm Constants
#define    AES_KEY_SIZES_BITS          {128}
#define    MAX_AES_KEY_BITS            128
#define    MAX_AES_BLOCK_SIZE_BYTES    16
#define    MAX_AES_KEY_BYTES           ((MAX_AES_KEY_BITS + 7) / 8)    // 16


// Table 219 -- SM4 Algorithm Constants
#define    SM4_KEY_SIZES_BITS          {128}
#define    MAX_SM4_KEY_BITS            128
#define    MAX_SM4_BLOCK_SIZE_BYTES    16
#define    MAX_SM4_KEY_BYTES           ((MAX_SM4_KEY_BITS + 7) / 8)    // 16


// Table 220 -- Symmetric Algorithm Constants
#define    MAX_SYM_KEY_BITS      MAX_AES_KEY_BITS    // 128
#define    MAX_SYM_KEY_BYTES     MAX_AES_KEY_BYTES    // 16
#define    MAX_SYM_BLOCK_SIZE    MAX_AES_BLOCK_SIZE_BYTES    // 16


// Table 221 -- Implementation Values
#define    FIELD_UPGRADE_IMPLEMENTED      NO    // 0
typedef    UINT16                         BSIZE;
#define    BUFFER_ALIGNMENT               4
#define    IMPLEMENTATION_PCR             24
#define    PLATFORM_PCR                   24
#define    DRTM_PCR                       17
#define    NUM_LOCALITIES                 5
#define    MAX_HANDLE_NUM                 3
#define    MAX_ACTIVE_SESSIONS            64
typedef    UINT16                         CONTEXT_SLOT;
typedef    UINT64                         CONTEXT_COUNTER;
#define    MAX_LOADED_SESSIONS            3
#define    MAX_SESSION_NUM                3
#define    MAX_LOADED_OBJECTS             3
#define    MIN_EVICT_OBJECTS              2
#define    PCR_SELECT_MIN                 ((PLATFORM_PCR+7)/8)    // 3
#define    PCR_SELECT_MAX                 ((IMPLEMENTATION_PCR+7)/8)    // 3
#define    NUM_POLICY_PCR_GROUP           1
#define    NUM_AUTHVALUE_PCR_GROUP        1
#define    MAX_CONTEXT_SIZE               4000
#define    MAX_DIGEST_BUFFER              1024
#define    MAX_NV_INDEX_SIZE              1024
#define    MAX_CAP_BUFFER                 1024
#define    NV_MEMORY_SIZE                 16384
#define    NUM_STATIC_PCR                 16
#define    MAX_ALG_LIST_SIZE              64
#define    TIMER_PRESCALE                 100000
#define    PRIMARY_SEED_SIZE              32
#define    CONTEXT_ENCRYPT_ALG            TPM_ALG_AES
#define    CONTEXT_ENCRYPT_KEY_BITS       MAX_SYM_KEY_BITS    // 128
#define    CONTEXT_ENCRYPT_KEY_BYTES      ((CONTEXT_ENCRYPT_KEY_BITS+7)/8)
#define    CONTEXT_INTEGRITY_HASH_ALG     TPM_ALG_SHA256
#define    CONTEXT_INTEGRITY_HASH_SIZE    SHA256_DIGEST_SIZE    // 32
#define    PROOF_SIZE                     CONTEXT_INTEGRITY_HASH_SIZE    // 32
#define    NV_CLOCK_UPDATE_INTERVAL       12
#define    NUM_POLICY_PCR                 1
#define    MAX_COMMAND_SIZE               4096
#define    MAX_RESPONSE_SIZE              4096
#define    ORDERLY_BITS                   8
#define    MAX_ORDERLY_COUNT              ((1 << ORDERLY_BITS) - 1)    // 255
#define    ALG_ID_FIRST                   TPM_ALG_FIRST
#define    ALG_ID_LAST                    TPM_ALG_LAST
#define    MAX_SYM_DATA                   128
#define    MAX_HASH_STATE_SIZE            512
#define    MAX_RNG_ENTROPY_SIZE           64
#define    RAM_INDEX_SPACE                512
#define    RSA_DEFAULT_PUBLIC_EXPONENT    0x00010001
#define    ENABLE_PCR_NO_INCREMENT        YES    // 1


#define MAX_HASH_BLOCK_SIZE 0
#define MAX_DIGEST_SIZE     0

#if (SHA1_BLOCK_SIZE * ALG_SHA1) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE SHA1_BLOCK_SIZE
#endif

#if (SHA1_DIGEST_SIZE * ALG_SHA1) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE SHA1_DIGEST_SIZE
#endif

#if (SHA256_BLOCK_SIZE * ALG_SHA256) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE SHA256_BLOCK_SIZE
#endif

#if (SHA256_DIGEST_SIZE * ALG_SHA256) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE SHA256_DIGEST_SIZE
#endif

#if (SHA384_BLOCK_SIZE * ALG_SHA384) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE SHA384_BLOCK_SIZE
#endif

#if (SHA384_DIGEST_SIZE * ALG_SHA384) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE SHA384_DIGEST_SIZE
#endif

#if (SHA512_BLOCK_SIZE * ALG_SHA512) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE SHA512_BLOCK_SIZE
#endif

#if (SHA512_DIGEST_SIZE * ALG_SHA512) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE SHA512_DIGEST_SIZE
#endif

#if (WHIRLPOOL512_BLOCK_SIZE * ALG_WHIRLPOOL512) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE WHIRLPOOL512_BLOCK_SIZE
#endif

#if (WHIRLPOOL512_DIGEST_SIZE * ALG_WHIRLPOOL512) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE WHIRLPOOL512_DIGEST_SIZE
#endif

#if (SM3_256_BLOCK_SIZE * ALG_SM3_256) > MAX_HASH_BLOCK_SIZE
#undef  MAX_HASH_BLOCK_SIZE
#define MAX_HASH_BLOCK_SIZE SM3_256_BLOCK_SIZE
#endif

#if (SM3_256_DIGEST_SIZE * ALG_SM3_256) > MAX_DIGEST_SIZE
#undef  MAX_DIGEST_SIZE
#define MAX_DIGEST_SIZE SM3_256_DIGEST_SIZE
#endif

#define HASH_COUNT (\
    ALG_SHA1+ALG_SHA256+ALG_SHA384+ALG_SHA512+ALG_WHIRLPOOL512+ALG_SM3_256)

//
// Part2Parser Generated (Oct 15, 2012 01:32:33 PM)
//

// Table 7 -- TPM_ALG_ID Constants <I/O,S>
typedef UINT16 TPM_ALG_ID;

#define    TPM_ALG_ERROR             (TPM_ALG_ID)(0x0000)        // a: ; D: 
#define    TPM_ALG_FIRST             (TPM_ALG_ID)(0x0001)        // a: ; D: 
#if ALG_RSA == YES || ALG_ALL == YES
//#define    TPM_ALG_RSA               (TPM_ALG_ID)(0x0001)        // a: A O; D: 
#endif
#if ALG_DES == YES || ALG_ALL == YES
#define    TPM_ALG_DES               (TPM_ALG_ID)(0x0002)        // a: S; D: 
#endif
#if ALG__3DES == YES || ALG_ALL == YES
#define    TPM_ALG__3DES             (TPM_ALG_ID)(0x0003)        // a: S; D: 
#endif
#if ALG_SHA1 == YES || ALG_ALL == YES
//#define    TPM_ALG_SHA               (TPM_ALG_ID)(0x0004)        // a: H; D: 
#endif
#if ALG_SHA1 == YES || ALG_ALL == YES
#define    TPM_ALG_SHA1              (TPM_ALG_ID)(0x0004)        // a: H; D: 
#endif
#if ALG_HMAC == YES || ALG_ALL == YES
//#define    TPM_ALG_HMAC              (TPM_ALG_ID)(0x0005)        // a: H X; D: 
#endif
#if ALG_AES == YES || ALG_ALL == YES
//#define    TPM_ALG_AES               (TPM_ALG_ID)(0x0006)        // a: S; D: 
#endif
#if ALG_MGF1 == YES || ALG_ALL == YES
//#define    TPM_ALG_MGF1              (TPM_ALG_ID)(0x0007)        // a: H M; D: 
#endif
#if ALG_KEYEDHASH == YES || ALG_ALL == YES
#define    TPM_ALG_KEYEDHASH         (TPM_ALG_ID)(0x0008)        // a: H E X O; D: 
#endif
#if ALG_XOR == YES || ALG_ALL == YES
//#define    TPM_ALG_XOR               (TPM_ALG_ID)(0x000A)        // a: H S; D: 
#endif
#if ALG_SHA256 == YES || ALG_ALL == YES
#define    TPM_ALG_SHA256            (TPM_ALG_ID)(0x000B)        // a: H; D: 
#endif
#if ALG_SHA384 == YES || ALG_ALL == YES
#define    TPM_ALG_SHA384            (TPM_ALG_ID)(0x000C)        // a: H; D: 
#endif
#if ALG_SHA512 == YES || ALG_ALL == YES
#define    TPM_ALG_SHA512            (TPM_ALG_ID)(0x000D)        // a: H; D: 
#endif
#if ALG_WHIRLPOOL512 == YES || ALG_ALL == YES
#define    TPM_ALG_WHIRLPOOL512      (TPM_ALG_ID)(0x000E)        // a: H; D: 
#endif
#define    TPM_ALG_NULL              (TPM_ALG_ID)(0x0010)        // a: ; D: 
#if ALG_SM3_256 == YES || ALG_ALL == YES
#define    TPM_ALG_SM3_256           (TPM_ALG_ID)(0x0012)        // a: H; D: 
#endif
#if ALG_SM4 == YES || ALG_ALL == YES
#define    TPM_ALG_SM4               (TPM_ALG_ID)(0x0013)        // a: S; D: 
#endif
#if ALG_RSASSA == YES || ALG_ALL == YES
#define    TPM_ALG_RSASSA            (TPM_ALG_ID)(0x0014)        // a: A X; D: RSA 
#endif
#if ALG_RSAES == YES || ALG_ALL == YES
#define    TPM_ALG_RSAES             (TPM_ALG_ID)(0x0015)        // a: A E; D: RSA 
#endif
#if ALG_RSAPSS == YES || ALG_ALL == YES
#define    TPM_ALG_RSAPSS            (TPM_ALG_ID)(0x0016)        // a: A X; D: RSA 
#endif
#if ALG_OAEP == YES || ALG_ALL == YES
#define    TPM_ALG_OAEP              (TPM_ALG_ID)(0x0017)        // a: A E; D: RSA 
#endif
#if ALG_ECDSA == YES || ALG_ALL == YES
#define    TPM_ALG_ECDSA             (TPM_ALG_ID)(0x0018)        // a: A X; D: ECC 
#endif
#if ALG_ECDH == YES || ALG_ALL == YES
#define    TPM_ALG_ECDH              (TPM_ALG_ID)(0x0019)        // a: A M; D: ECC 
#endif
#if ALG_ECDAA == YES || ALG_ALL == YES
#define    TPM_ALG_ECDAA             (TPM_ALG_ID)(0x001A)        // a: A X; D: ECC 
#endif
#if ALG_SM2 == YES || ALG_ALL == YES
#define    TPM_ALG_SM2               (TPM_ALG_ID)(0x001B)        // a: A X E; D: ECC 
#endif
#if ALG_ECSCHNORR == YES || ALG_ALL == YES
#define    TPM_ALG_ECSCHNORR         (TPM_ALG_ID)(0x001C)        // a:  A X; D: ECC 
#endif
#if ALG_KDF1_SP800_56a == YES || ALG_ALL == YES
#define    TPM_ALG_KDF1_SP800_56a    (TPM_ALG_ID)(0x0020)        // a: H M; D: ECC 
#endif
#if ALG_KDF2 == YES || ALG_ALL == YES
#define    TPM_ALG_KDF2              (TPM_ALG_ID)(0x0021)        // a: H M; D: 
#endif
#if ALG_KDF1_SP800_108 == YES || ALG_ALL == YES
#define    TPM_ALG_KDF1_SP800_108    (TPM_ALG_ID)(0x0022)        // a: H M; D: 
#endif
#if ALG_ECC == YES || ALG_ALL == YES
#define    TPM_ALG_ECC               (TPM_ALG_ID)(0x0023)        // a: A O; D: 
#endif
#if ALG_SYMCIPHER == YES || ALG_ALL == YES
#define    TPM_ALG_SYMCIPHER         (TPM_ALG_ID)(0x0025)        // a: O; D: 
#endif
#if ALG_CTR == YES || ALG_ALL == YES
#define    TPM_ALG_CTR               (TPM_ALG_ID)(0x0040)        // a: S E; D: 
#endif
#if ALG_OFB == YES || ALG_ALL == YES
#define    TPM_ALG_OFB               (TPM_ALG_ID)(0x0041)        // a: S E; D: 
#endif
#if ALG_CBC == YES || ALG_ALL == YES
#define    TPM_ALG_CBC               (TPM_ALG_ID)(0x0042)        // a: S E; D: 
#endif
#if ALG_CFB == YES || ALG_ALL == YES
#define    TPM_ALG_CFB               (TPM_ALG_ID)(0x0043)        // a: S E; D: 
#endif
#if ALG_ECB == YES || ALG_ALL == YES
#define    TPM_ALG_ECB               (TPM_ALG_ID)(0x0044)        // a: S E; D: 
#endif
#define    TPM_ALG_LAST              (TPM_ALG_ID)(0x0044)        // a: ; D: 


// Table 8 -- TPM_ECC_CURVE Constants <I/O,S>
typedef UINT16 TPM_ECC_CURVE;

#define    TPM_ECC_NONE         (TPM_ECC_CURVE)(0x0000)    
#define    TPM_ECC_NIST_P192    (TPM_ECC_CURVE)(0x0001)    
#define    TPM_ECC_NIST_P224    (TPM_ECC_CURVE)(0x0002)    
#define    TPM_ECC_NIST_P256    (TPM_ECC_CURVE)(0x0003)    
#define    TPM_ECC_NIST_P384    (TPM_ECC_CURVE)(0x0004)    
#define    TPM_ECC_NIST_P521    (TPM_ECC_CURVE)(0x0005)    
#define    TPM_ECC_BN_P256      (TPM_ECC_CURVE)(0x0010)    
#define    TPM_ECC_BN_P638      (TPM_ECC_CURVE)(0x0011)    
#define    TPM_ECC_SM2_P256     (TPM_ECC_CURVE)(0x0020)    



#endif
